org.apache.fop.render.ps

## Class PSDocumentHandler

- java.lang.Object
- - org.apache.fop.render.intermediate.AbstractIFDocumentHandler
  - - org.apache.fop.render.intermediate.AbstractBinaryWritingIFDocumentHandler
    - - org.apache.fop.render.ps.PSDocumentHandler

- All Implemented Interfaces:
    IFDocumentHandler

      public class PSDocumentHandler
      extends AbstractBinaryWritingIFDocumentHandler

  `IFDocumentHandler` implementation that produces PostScript.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `PSDocumentHandler.FOPPSGenerator`
    `class` | `PSDocumentHandler.FOPPSGeneratorImpl`

  - ### Field Summary

    - ### Fields inherited from class org.apache.fop.render.intermediate.AbstractBinaryWritingIFDocumentHandler

      `fontInfo, outputStream`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PSDocumentHandler(IFContext context)` Default constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `endDocument()` Indicates the end of a document.
    `void` | `endDocumentHeader()` Indicates the end of the document header.
    `void` | `endPage()` Indicates the end of a page
    `void` | `endPageContent()` Indicates the end of the page content.
    `void` | `endPageHeader()` Indicates the end of the page header.
    `void` | `endPageSequence()` Indicates the end of a page sequence.
    `void` | `endPageTrailer()` Indicates the end of the page trailer.
    `IFDocumentHandlerConfigurator` | `getConfigurator()` Returns the configurator for this document handler, if any.
    `org.apache.xmlgraphics.ps.PSResource` | `getFormForImage(String uri)` Returns a PSResource instance representing a image as a PostScript form.
    `String` | `getMimeType()` Returns the MIME type of the output format that is generated by this implementation.
    `protected org.apache.fop.render.ps.PSFontResource` | `getPSResourceForFontKey(String key)` Returns the PSResource for the given font key.
    `PSRenderingUtil` | `getPSUtil()`
    `void` | `handleExtensionObject(Object extension)` Handles an extension object.
    `void` | `startDocument()` Indicates the start of a document.
    `void` | `startPage(int index, String name, String pageMasterName, Dimension size)` Indicates the start of a new page.
    `IFPainter` | `startPageContent()` Indicates the start of the page content.
    `void` | `startPageHeader()` Indicates the start of the page header.
    `void` | `startPageSequence(String id)` Indicates the start of a new page sequence.
    `void` | `startPageTrailer()` Indicates the start of the page trailer.
    `boolean` | `supportsPagesOutOfOrder()` Indicates whether the painter supports to handle the pages in mixed order rather than ascending order.

    - ### Methods inherited from class org.apache.fop.render.intermediate.AbstractBinaryWritingIFDocumentHandler

      `getFontInfo, setDefaultFontInfo, setFontInfo, setResult`

    - ### Methods inherited from class org.apache.fop.render.intermediate.AbstractIFDocumentHandler

      `endDocumentTrailer, getContext, getDocumentNavigationHandler, getStructureTreeEventHandler, getUserAgent, setDocumentLocale, startDocumentHeader, startDocumentTrailer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PSDocumentHandler

          public PSDocumentHandler(IFContext context)

      Default constructor.

  - ### Method Detail

    - #### supportsPagesOutOfOrder

          public boolean supportsPagesOutOfOrder()

      Indicates whether the painter supports to handle the pages in mixed order rather than ascending order.
      Returns:
        true if out-of-order handling is supported

    - #### getMimeType

          public String getMimeType()

      Returns the MIME type of the output format that is generated by this implementation.
      Returns:
        the MIME type

    - #### getConfigurator

          public IFDocumentHandlerConfigurator getConfigurator()

      Returns the configurator for this document handler, if any.
      Returns:
        the configurator or null if there's no configurator

    - #### getPSUtil

          public PSRenderingUtil getPSUtil()

    - #### startDocument

          public void startDocument()
                             throws IFException

      Indicates the start of a document. This method may only be called once before any other event method.
      Specified by:
        `startDocument` in interface `IFDocumentHandler`
      Overrides:
        `startDocument` in class `AbstractBinaryWritingIFDocumentHandler`
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### endDocumentHeader

          public void endDocumentHeader()
                                 throws IFException

      Indicates the end of the document header. This method is called before the first page sequence.
      Specified by:
        `endDocumentHeader` in interface `IFDocumentHandler`
      Overrides:
        `endDocumentHeader` in class `AbstractIFDocumentHandler`
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### endDocument

          public void endDocument()
                           throws IFException

      Indicates the end of a document. This method may only be called once after the whole document has been handled. Implementations can release resources (close streams). It is an error to call any event method after this method.
      Specified by:
        `endDocument` in interface `IFDocumentHandler`
      Overrides:
        `endDocument` in class `AbstractBinaryWritingIFDocumentHandler`
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### startPageSequence

          public void startPageSequence(String id)
                                 throws IFException

      Indicates the start of a new page sequence.
      Parameters:
        `id` - the page sequence's identifier (or null if none is available)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### endPageSequence

          public void endPageSequence()
                               throws IFException

      Indicates the end of a page sequence.
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### startPage

          public void startPage(int index,
                                String name,
                                String pageMasterName,
                                Dimension size)
                         throws IFException

      Indicates the start of a new page.
      Parameters:
        `index` - the index of the page (0-based)
        `name` - the page name (usually the formatted page number)
        `pageMasterName` - the name of the simple-page-master that generated this page
        `size` - the size of the page (equivalent to the MediaBox in PDF)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### startPageHeader

          public void startPageHeader()
                               throws IFException

      Indicates the start of the page header.
      Specified by:
        `startPageHeader` in interface `IFDocumentHandler`
      Overrides:
        `startPageHeader` in class `AbstractIFDocumentHandler`
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### endPageHeader

          public void endPageHeader()
                             throws IFException

      Indicates the end of the page header.
      Specified by:
        `endPageHeader` in interface `IFDocumentHandler`
      Overrides:
        `endPageHeader` in class `AbstractIFDocumentHandler`
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### startPageContent

          public IFPainter startPageContent()
                                     throws IFException

      Indicates the start of the page content. The method returns an `IFPainter` interface which is used to paint the page contents.
      Returns:
        the IFPainter for the page content
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### endPageContent

          public void endPageContent()
                              throws IFException

      Indicates the end of the page content. Calls to the `IFPainter` returned by the respective `IFDocumentHandler.startPageContent()` method are illegal.
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### startPageTrailer

          public void startPageTrailer()
                                throws IFException

      Indicates the start of the page trailer. The page trailer is used for writing down page elements which are only know after handling the page itself (like PDF targets).
      Specified by:
        `startPageTrailer` in interface `IFDocumentHandler`
      Overrides:
        `startPageTrailer` in class `AbstractIFDocumentHandler`
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### endPageTrailer

          public void endPageTrailer()
                              throws IFException

      Indicates the end of the page trailer.
      Specified by:
        `endPageTrailer` in interface `IFDocumentHandler`
      Overrides:
        `endPageTrailer` in class `AbstractIFDocumentHandler`
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### endPage

          public void endPage()
                       throws IFException

      Indicates the end of a page
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### handleExtensionObject

          public void handleExtensionObject(Object extension)
                                     throws IFException

      Handles an extension object. This can be a DOM document or any arbitrary object. If an implementation doesn't know how to handle a particular extension it is simply ignored.
      Parameters:
        `extension` - the extension object
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### getPSResourceForFontKey

          protected org.apache.fop.render.ps.PSFontResource getPSResourceForFontKey(String key)

      Returns the PSResource for the given font key.
      Parameters:
        `key` - the font key ("F*")
      Returns:
        the matching PSResource

    - #### getFormForImage

          public org.apache.xmlgraphics.ps.PSResource getFormForImage(String uri)

      Returns a PSResource instance representing a image as a PostScript form.
      Parameters:
        `uri` - the image URI
      Returns:
        a PSResource instance

Copyright © 2023 Apache Software Foundation. All rights reserved.